#include "sdk.h"

extern void evmboardinit();

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna joystick. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	//P4.0, P4.1, P4.2, P4.3, P0.7 
	
	*R_GPIDIR(4) = 1<<3 | 1<<2 | 1<<1 | 1<<0;  // P4.0, P4.1, P4.2, P4.3 input
	*R_GPIDIR(0) = 1<<7 ;  // P0.7 input
	
	U8 stick_val = 0;
	U8 push_val = 0;
	U8 old_stick_val = 0;	
	U8 old_push_val = 0;
	
	while(1)
	{
		stick_val = *R_GPILEV(4) &0xf;
		if(old_stick_val != stick_val)
		{
			switch(stick_val)
			{
				case 0xE:
					debugprintf("up\r\n");
					break;
				case 0xD:
					debugprintf("left\r\n");
					break;
				case 0xB:
					debugprintf("down\r\n");
					break;
				case 0x7:
					debugprintf("right\r\n");
					break;
			}			
			old_stick_val = stick_val;
		}
		
		push_val = (*R_GPILEV(0) >>7) & 1;
		if(old_push_val != push_val)
		{
			if(push_val == 0)
			{
				debugprintf("button push\r\n");
			}
		}		
		old_push_val = push_val;
	}
	
	while(1);
	return 0;
}
