#include "sdk.h"

extern void evmboardinit();

U32 get_adc(U8 ch)
{
    U32 adc_res=0;	
	*R_ADCCTRL2 = 1;
    *R_ADCCTRL = ch << 5 | F_ADCCTRL_APB128 | F_ADCCTRL_EN | F_ADCCTRL_STC;	    

    while(!(*R_ADCSTAT&F_ADCSTAT_ADCDR));
    *R_ADCCTRL = 0;
	
    adc_res = *R_ADCDATA&0xfff;    
	
    return adc_res;
}

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna ADC. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	*R_GPODIR(5) = 1<<6;  // 5.6 output
	U32 adc_dat = 0;
	
	while(1)
	{				
		adc_dat = get_adc(1);
		debugprintf("ADC ch 1 = 0x%x\r\n",adc_dat);			
		if(adc_dat < 0x200)
		{
			*R_GPOLOW(5) = 1<<6;
		}
		else
		{
			*R_GPOHIGH(5) = 1<<6;
		}
	}
	
	return 0;
}