#include "sdk.h"

extern void evmboardinit();

// buzzer_dat[] = { freq-1, count-1, freq-2, count-2, .... , freq-N, count-N, 0, 0}; 

int buzzer_dat[] = {261,40,329,40,391,50,523,50,0,0};
int buzzer_cur = 0;

void PWM_ISR()
{
	if(buzzer_dat[buzzer_cur] == 0) // freq == 0, pwm off
	{
		set_pwm(0, buzzer_dat[buzzer_cur], buzzer_dat[buzzer_cur+1], false, false);  
		return;
	}
	set_pwm(0, buzzer_dat[buzzer_cur], buzzer_dat[buzzer_cur+1], false, true);  
	buzzer_cur+=2;
}

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna Buzzer. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");

	set_interrupt(INTNUM_TIMER0,PWM_ISR);
	enable_interrupt(INTNUM_TIMER0,true);
	
	set_pwm(0, buzzer_dat[buzzer_cur], buzzer_dat[buzzer_cur+1],false, true);  // PWM channel 0, 60Hz, pulse count 100 -> occur interrupt.
	buzzer_cur+=2;
	
	while(1);
	return 0;
}
