#include "sdk.h"

extern void evmboardinit();

#define GPIO_INT		

#ifdef GPIO_INT	

U8 pio_flag = 0;

void GPIO_ISR()
{
	debugprintf("GPIO 6.2 Falling edge ISR\r\n");
	if(pio_flag)
	{
		*R_GPOHIGH(5) = 1<<6;		
		pio_flag = 0;
	}
	else
	{
		*R_GPOLOW(5) = 1<<6;		
		pio_flag = 1;
	}
}

#endif

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna GPIO. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	//P6.0, P6.1	
	*R_GPIDIR(6) = 1<<8|1<<2 ;  // P6.2 input		
	*R_GPODIR(5) = 1<<6;  // 5.6 output
	
#ifdef GPIO_INT		
		
	*R_GPIRQMODE(6) = 0x2; // Falling interrupt Mode
	*R_GPIRQEN(6) = 1<<2; // P6.2 Interrupt enable
	set_interrupt(INTNUM_GPIO6, GPIO_ISR);	
	enable_interrupt(INTNUM_GPIO6, true);		
	
#else 
	
	U8 input = (*R_GPILEV(6) >> 2) & 1;
	while(1)
	{
		input = (*R_GPILEV(6) >> 2) & 1;
		debugprintf("P6.2 level = 0x%x\r\n",input);
		if(!input)
		{
			*R_GPOLOW(5) = 1<<6;
		}
		else
		{
			*R_GPOHIGH(5) = 1<<6;
		}
		
	}
#endif
	
	while(1)
	{
		
	}
	return 0;
}
