#include "sdk.h"
#include "etc_driver/KTD2061.h"

extern void evmboardinit();

/*
bool ktd_reset();
bool ktd_enable(U8 en_mod);
bool ktd_bright_ex(U8 b);
bool ktd_cool_ex(U8 temp);
bool ktd_fade_rate(U8 rate);
bool kdt_set_rgb0(U8 r, U8 g, U8 b);
bool kdt_set_rgb1(U8 r, U8 g, U8 b);
bool kdt_led_color(U16 sel_a, U16 sel_b, U16 sel_c, U8 color);
bool kdt_led_on(U16 sel_a, U16 sel_b, U16 sel_c, U8 b);
bool ktd_init();
*/

//#define MANUAL_COLOR	
	
int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna UART Rx/Tx. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");

	*R_GPIDIR(6) = 1<<2 | 1<<1 | 1<<0;  // P6.0, P6.1, P6.2 input
	
	ktd_reset();
	ktd_init();
	ktd_enable(CON_NIGHT_MODE); // NOMAL_MODE or NIGHT_MODE
	
	U8 input = (*R_GPILEV(6) >> 2) & 1;
	U8 b_input = 1;
	
	U8 value = 0;
	
#ifdef MANUAL_COLOR
	
	ktd_led_color(LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, 0);  // LED color = RGB0
	ktd_led_on(LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, true); // LED ON
	
	while(1)
	{
		input = (*R_GPILEV(6) >> 2) & 1;
		if(!input)
		{
			if(b_input)
			{
				switch(value)
				{
					case 0:
						ktd_set_rgb0(255,0,0);  // RGB0 color 
						value++;
					break;
					case 1:
						ktd_set_rgb0(0,255,0);  // RGB0 color 
						value++;
					break;
					case 2:
						ktd_set_rgb0(0,255,0);  // RGB0 color 
						value++;
					break;
					case 3:
						ktd_led_on(LED1|LED2|LED3|LED4, 0, 0, false); // LED A - 1,2,3,4 OFF
						value++;
					break;
					case 4:
						ktd_led_on(LED1|LED2|LED3|LED4, 0, 0, true); // LED A - 1,2,3,4 ON
						value = 0;
					break;
				}						
				b_input = 0;
			}
		}
		else
		{
			b_input = 1;
		}
		delayms(100);
	}		
	
#else
	
		/*
		0 -> off
		1 -> Blue
		2 -> Green
		3 -> Sky_Blue
		4 -> Red
		5 -> Purple
		6 -> Yellow
		7 -> White
	*/
	
	ktd_led_color(LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, 1);
	ktd_led_on(LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, true);	
	
	while(1)
	{
		input = (*R_GPILEV(6) >> 2) & 1;
		if(!input)
		{
			if(b_input)
			{
				switch(value)
				{
					case 0:
						ktd_led_color(LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, 4); // R, G, B = 255, 0, 0
						value++;
					break;
					case 1:
						ktd_led_color(LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, 2); // R, G, B = 0, 255, 0
						value++;
					break;
					case 2:
						ktd_led_color(LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, LED1|LED2|LED3|LED4, 1);// R, G, B = 0, 0, 255
						value++;
					break;
					case 3:
						ktd_led_on(LED1|LED2|LED3|LED4, 0, 0, false); // LED A - 1,2,3,4 OFF
						value++;
					break;
					case 4:
						ktd_led_on(LED1|LED2|LED3|LED4, 0, 0, true); // LED A - 1,2,3,4 OFN
						value = 0;
					break;
				}						
				b_input = 0;
			}			
		}
		else
		{
			b_input = 1;
		}
		delayms(100);
	}	
	
#endif
	

	
	while(1);
	return 0;
}
