#include "sdk.h"
#include "cm802_5.h"

void cm802_5_tx_complite(void)
{
	unsigned char stat;
	
	while(1)
	{
		stat = *R_SPISTAT(1);
		if(stat & SPISTAT_SPIF)
			break;
	}
}
void cm802_5_command(unsigned char cmd)
{
	_CM802_5_CSB_LOW;
	*R_SPIDATA(1) = cmd>>1;
	cm802_5_tx_complite();
	*R_SPIDATA(1) = cmd<<7;
	cm802_5_tx_complite();
	_CM802_5_CSB_HIGH;
}

void cm802_5_data(unsigned char lcd_data)
{
	_CM802_5_CSB_LOW;
	*R_SPIDATA(1) = (lcd_data>>1) | 0x80;
	cm802_5_tx_complite();
	*R_SPIDATA(1) = lcd_data<<7;
	cm802_5_tx_complite();
	_CM802_5_CSB_HIGH;
}

void cm802_5_init(void)
{
	cm802_5_command(0x30);
    delayms(1);
	cm802_5_command(0x30);
    delayms(1);
	cm802_5_command(0x30);
    delayms(5);
   	cm802_5_command(0x38);
    delayms(1);
	cm802_5_command(0x08);// display on
    delayms(10);
	cm802_5_command(0x01);// clear display
    delayms(10);
	cm802_5_command(0x06);// entry mode
    delayms(10);
	cm802_5_command(0x0C);// set display 
    delayms(100);
}

void cm802_5_set(void)
{
	*R_PAF(5) &= ~((0x3<<8) | (0x3<<10) | (0x3<<14));// SPI
	
//	*R_SPICON(1) = SPICON_EN | SPICON_MSTR | SPICON_CPOL | SPICON_MSBF;
	*R_SPICON(1) = SPICON_EN | SPICON_MSTR | SPICON_MSBF;
	*R_SPIBAUD(1) = 10; //4.8MHz
}

void cm802_5_clear(void)
{
	cm802_5_command(0x1);
    delayms(5);
}
void cm802_5_move_cursor(unsigned char x, unsigned char y)
{
	unsigned char z=0;
	
	z=x+(y&0x01)*0x40;
	cm802_5_command(_LCD_MOV_CUR|z);
	delayms(2);
}
void cm802_5_putstring(unsigned char x,  unsigned char y, unsigned char *str)
{
	volatile U32 delayt;
	cm802_5_move_cursor(x, y);
	while(*str)
	{
		cm802_5_data(*str);
		*str++;
		for(delayt=0; delayt<380; delayt++);// data data ð 
		//for(delayt=0; delayt<600; delayt++);// data data ð 
		x++;
		if((x%8) == 0)
		{
			y++;
			x=0;
			if(y>=2)y=0;
			cm802_5_move_cursor(x,y);
		}
	}
}
