#include "sdk.h"
#include "cm802_5.h"

extern void evmboardinit();

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna LCD. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	cm802_5_set();
	cm802_5_init();
	cm802_5_putstring(0,0 ,"*adLuna*");
	cm802_5_putstring(0,1 ,"12345678");	
	
	*R_GPIDIR(4) = 1<<3 | 1<<2 | 1<<1 | 1<<0;  // P4.0, P4.1, P4.2, P4.3 input
	*R_GPIDIR(0) = 1<<7 ;  // P0.7 input
	
	U8 stick_val = 0;
	U8 push_val = 0;
	U8 old_stick_val = 0;	
	U8 old_push_val = 0;
	
	while(1)
	{
		stick_val = *R_GPILEV(4) &0xf;
		if(old_stick_val != stick_val)
		{
			switch(stick_val)
			{
				case 0xE:
					debugprintf("up\r\n");
					cm802_5_putstring(0,1 ,"up      ");	
					break;
				case 0xD:
					debugprintf("left\r\n");
					cm802_5_putstring(0,1 ,"left    ");	
					break;
				case 0xB:
					debugprintf("down\r\n");
					cm802_5_putstring(0,1 ,"down    ");	
					break;
				case 0x7:
					debugprintf("right\r\n");
					cm802_5_putstring(0,1 ,"right   ");	
					break;
			}			
			old_stick_val = stick_val;
		}		
	}
	return 0;
}
