#include "sdk.h"

extern void evmboardinit();

/*
	debugstring, debugpritnf output channel can be changed using the set_debug_channel.
	ex)
	       set_debug_channel(0);
	       uart_config(0, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);	
*/

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna IrDa System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	uart_config(0, 9600, DATABITS_8, STOPBITS_1, UART_PARNONE);
	uart_set_irda(0, false, false);   // Irda mode set, uart_set_irda(int ch, int rx_inversion, int tx_inversion);

	U8 ch;
	while(1)
	{		
		if(uart_getch(0,&ch))  // IrDa Rx
		{
			uart_putstring(5,"Rx data : ");
			uart_putch(5, ch);
			uart_putstring(5,"\r\n");
		}
		
		if(uart_getch(5,&ch))
		{			
			uart_putch(0, ch); // IrDa Tx
		}		
	}
	
	while(1);
	return 0;
}
