#include "sdk.h"

extern void evmboardinit();

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna WatchDog. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	// About 1000ms @ APB 48MHz
	// WDTCNT = ( Set_time(s) * APB Clk(Hz) )
	*R_WDTLCK = 0x1ACCE551; // Watchdog Timer Unlock.
	*R_WDTCNT = 0x2DC6C00;  // about 1sec @ APB 48Mhz
	*R_WDTCTRL = F_WDTCTRL_WDTMOD_RST | F_WDTCTRL_WDTEN_ENABLE;
	*R_WDTLCK = 0x0; // Watchdog Timer lock.
	
	while(1)
	{		
		// Set Watchdog Count.
		*R_WDTLCK = 0x1ACCE551; // Watchdog Timer Unlock.
		*R_WDTCNT = 0x2DC6C00;   // about 1sec @ APB 60Mhz
		*R_WDTLCK = 0x0; // Watchdog Timer lock.
		
	}
	
	
	return 0;
}