#include "sdk.h"

extern void evmboardinit();

INCBIN(okwave, "01.wav");  // Add 01.wav file data, 

int main()
{
	evmboardinit();
	uart_config(5, 115200, DATABITS_8, STOPBITS_1, UART_PARNONE);
	debugstring("================================================\r\n");  
	debugprintf("adLuna WAV Play. System Clock(%dMhz)\r\n", get_ahb_clock() / 1000000);
	debugstring("================================================\r\n");
	
	sound_init();	

	PRINTVAR(get_apb_clock());
	PRINTVAR(get_clock(DEV_CLOCK_MIXER_AMP));
	
	sound_vol(235);    // sound vol, max = 255 (default)
		
	WAVE* pWavOK = sound_loadwavp((U8*)okwave_data, okwave_end - okwave_data);
	                            // okwave_data => 01.wav file data
	                            // okwave_end - okwave_data => 01.wav file size
	
	// AMP Shut down disable
	*R_PAF(5) |= 3<<12;
	*R_GPODIR(5) = 1<<6;
	*R_GPOHIGH(5) = 1<<6;
	
	while (1)
	{
		sound_play(pWavOK);
		while (sound_isplay(pWavOK));
		delayms(1000);
	}
	
	while(1);
	return 0;
}
