#pragma once

#define CONTROL_REG	0x2

#define CON_GLOBAL_OFF		(0x0 << 6)
#define CON_NIGHT_MODE  	(0x1 << 6)
#define CON_NOMAL_MODE	(0x2 << 6)
#define CON_RESET				(0x3 << 6)

#define CON_BRIGHT_EN			(0x1 << 5)
#define CON_BRIGHT_DIS		(0x0 << 5)

#define CON_COOL_135			(0x0 << 3)
#define CON_COOL_120			(0x1 << 3)
#define CON_COOL_105			(0x2 << 3)
#define CON_COOL_90			(0x3 << 3)

#define CON_FADE_31				(0x0 << 0)
#define CON_FADE_63				(0x1 << 0)
#define CON_FADE_125			(0x2 << 0)
#define CON_FADE_250			(0x3 << 0)
#define CON_FADE_500			(0x4 << 0)
#define CON_FADE_1S				(0x5 << 0)
#define CON_FADE_2S				(0x6 << 0)
#define CON_FADE_4S				(0x7 << 0)

#define IRED0		0x3
#define IGRN0		0x4
#define IBLU0		0x5

#define IRED1		0x6
#define IGRN1		0x7
#define IBLU1		0x8

#define ISELA12	0x9

#define ISELA_ENA1					(1 << 7)
#define ISELA_ENA2					(1 << 3)

#define ISELA34	0xA

#define ISELA_ENA3					(1 << 7)
#define ISELA_ENA4					(1 << 3)

#define ISELB12	0xB

#define ISELB_ENB1				(1 << 7)
#define ISELB_ENB2				(1 << 3)

#define ISELB34	0xC

#define ISELB_ENB3				(1 << 7)
#define ISELB_ENB4				(1 << 3)

#define ISELC12	0xD

#define ISELC_ENC1				(1 << 7)
#define ISELC_ENC2				(1 << 3)

#define ISELC34	0xE

#define ISELC_ENC3				(1 << 7)
#define ISELC_ENC4				(1 << 3)

#define LED1 	0x1
#define LED2 	0x2
#define LED3 	0x4
#define LED4 	0x8

bool ktd_reset();
bool ktd_enable(U8 en_mod);
bool ktd_bright_ex(U8 b);
bool ktd_cool_ex(U8 temp);
bool ktd_fade_rate(U8 rate);
bool ktd_set_rgb0(U8 r, U8 g, U8 b);
bool ktd_set_rgb1(U8 r, U8 g, U8 b);
bool ktd_led_color(U16 sel_a, U16 sel_b, U16 sel_c, U8 color);
bool ktd_led_on(U16 sel_a, U16 sel_b, U16 sel_c, U8 b);
bool ktd_init();
